<?php

/*
*
* INFOATCLUSTER TECHNOLABS LLP ("COMPANY") CONFIDENTIAL
* Copyright (c) 2016-2017 INFOATCLUSTER TECHNOLABS LLP, All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains the property of INFOATCLUSTER TECHNOLABS LLP. The intellectual and technical concepts contained
* herein are proprietary to INFOATCLUSTER TECHNOLABS LLP and may be covered by Indian and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
* Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained
* from COMPANY.  Access to the source code contained herein is hereby forbidden to anyone except current COMPANY employees, managers or contractors who have executed 
* Confidentiality and Non-disclosure agreements explicitly covering such access.
*
* The copyright notice above does not evidence any actual or intended publication or disclosure  of  this source code, which includes  
* information that is confidential and/or proprietary, and is a trade secret, of  COMPANY.   ANY REPRODUCTION, MODIFICATION, DISTRIBUTION, PUBLIC  PERFORMANCE, 
* OR PUBLIC DISPLAY OF OR THROUGH USE  OF THIS  SOURCE CODE  WITHOUT  THE EXPRESS WRITTEN CONSENT OF COMPANY IS STRICTLY PROHIBITED, AND IN VIOLATION OF APPLICABLE 
* LAWS AND INTERNATIONAL TREATIES.  THE RECEIPT OR POSSESSION OF  THIS SOURCE CODE AND/OR RELATED INFORMATION DOES NOT CONVEY OR IMPLY ANY RIGHTS  
* TO REPRODUCE, DISCLOSE OR DISTRIBUTE ITS CONTENTS, OR TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT  MAY DESCRIBE, IN WHOLE OR IN PART.                
*
*
* @author Mohammed Shayas M K
* 
*/

namespace App\Managers\PlayerRatings;
use App\Managers\PlayerRatings\PlayerRatingsModel;
use App\Managers\PlayerRatingSubstitute\PlayerRatingSubstituteManager;
use App\Managers\PlayerRatingsVotes\PlayerRatingsVotesManager;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Session;
use App\Managers\User\UserManager;
use Illuminate\Support\Facades\DB;
use App\Http\Helper\Helper;
use App\Managers\Paypal\PaypalManager;

class PlayerRatingsManager extends PlayerRatingsModel
{
    public function __construct()
    {
         $this->helper = new Helper();
         $this->playerRatingSubstitute = new PlayerRatingSubstituteManager();
         $this->paypal = new PaypalManager();
         $this->playerRatingsVote = new PlayerRatingsVotesManager();
    }

    public function insertData($columns, $data1, $scheduleID)
    {
        DB::beginTransaction();
        try 
        {
            $userBalanceVote = $data1['no_of_votes'];
            $current = date("Y-m-d H:i:s");
            $data1['scheduled_id'] = $scheduleID;
            $data1['user_id'] = Session::get('general');
            $data1['created_at'] = $data1['updated_at'] = $current;
            $data1['UUID'] = $this->helper->addUuid();
            
            $substitute = $this->playerRatingSubstitute->insert($data1);
            if(!$substitute)
            {
                return 0;
            }
            foreach($columns AS $key => $value)
            {
                $data = array();
                $data['rating'] = $value;
                $data['player_ratings_substitute_id'] = $data1['UUID'];
                $data['scheduled_players_id'] = $key;
                $data['user_id'] = Session::get('general');
                $data['created_at'] = $data['updated_at'] = $current;
                $data['UUID'] = $this->helper->addUuid();
                $insert = $this->insert($data);
                if(!$insert)
                {
                    return 0;
                }
            }
            
            $votes = $this->paypal->getAllCreditsOfUser(Session::get('general'));
            
            $data2['votes'] = $userBalanceVote;
            $data2['schedule_id'] = $scheduleID;
            $data2['user_id'] = Session::get('general');
            $data2['UUID'] = $this->helper->addUuid();
            $data2['created_at'] = $data2['updated_at'] = $current;
            
            $voteInsert = $this->playerRatingsVote->insertData($data2);
            if(!$voteInsert)
            {
                return 0;
            }
            
//            foreach($votes AS $vote)
//            {
//                if($end == 0 && $vote['no_of_votes'] > $vote['used_votes'])
//                {
//                    $balanceVoteForTransaction = $vote['no_of_votes'] - $vote['used_votes'];
//                    $availableVote = $vote['no_of_votes'];
//                    if($balanceVoteForTransaction == $userBalanceVote || $balanceVoteForTransaction > $userBalanceVote)
//                    {
//                        $availableVote = ($userBalanceVote + $vote['used_votes']);
//                        $end = 1;
//                    }
//                    
//                    $data2['used_votes'] = $availableVote;
//                    $update = $this->paypal->where('id', $vote['id'])->update($data2);
//                    if(!$update)
//                    {
//                        return 0;
//                        exit;
//                    }
//
//                    $userBalanceVote = $userBalanceVote - $balanceVoteForTransaction;
//                }
//            }
            
            DB::commit();
            return 1;
        }
        catch(ValidationException $e)
        {
            DB::rollback();
            return 0;
        }
        
    }
    
    public function getColumnsOfCurrentPosition($positionID)
    {
        return $this->where('position_id', $positionID)->get();
    }
    
    public function checkCurrentSchedule($columns, $data)
    {
        
            foreach($columns AS $key => $value)
            {
                $res = $this->where('scheduled_players_id', $key)->where('user_id', Session::get('general'))->first();

                if($res)
                {
                    $errors['errors'][] = 'This is already rated by you';
                   // return $errors;
                }
            }
    }
    
    public function getPlayerRatingsForSchedule($scheduleID)
    {
        return $this->select(DB::raw("SUM(player_ratings.rating * player_ratings_substitute.no_of_votes)/(SUM(player_ratings_substitute.no_of_votes)) as rating_count"), "schedule_players.UUID AS schedule_players_id", "schedule_players.player_id")
                ->join('schedule_players', 'schedule_players.UUID', '=','player_ratings.scheduled_players_id')
                ->join('schedule', 'schedule.UUID', '=', 'schedule_players.schedule_id')
                ->join('player_ratings_substitute', 'player_ratings_substitute.UUID', '=', 'player_ratings.player_ratings_substitute_id')
                ->where('schedule.UUID', $scheduleID)
                ->groupBy('player_ratings.scheduled_players_id')
                ->get();
    }
    
    public function getPlayerRating($id)
    {
        return $this->select(DB::raw("SUM(player_ratings.rating * player_ratings_substitute.no_of_votes)/(SUM(player_ratings_substitute.no_of_votes)) as rating_count"))
                ->join('schedule_players', 'schedule_players.UUID', '=','player_ratings.scheduled_players_id')
                ->join('schedule', 'schedule.UUID', '=', 'schedule_players.schedule_id')
                ->join('player_ratings_substitute', 'player_ratings_substitute.UUID', '=', 'player_ratings.player_ratings_substitute_id')
                ->where('schedule_players.player_id', $id)
                ->first();
    }
    
    
    public function getPlayerRatingForEachSchedule($playerID, $limit)
    {
        return $this->select('schedule.UUID','schedule.name','schedule.date_date', DB::raw("ROUND(SUM(player_ratings.rating * player_ratings_substitute.no_of_votes)/(SUM(player_ratings_substitute.no_of_votes)),2) as rating_count"))
                ->join('schedule_players', 'schedule_players.UUID', '=','player_ratings.scheduled_players_id')
                ->join('schedule', 'schedule.UUID', '=', 'schedule_players.schedule_id')
                ->join('player_ratings_substitute', 'player_ratings_substitute.UUID', '=', 'player_ratings.player_ratings_substitute_id')
                ->where('schedule_players.player_id', $playerID)
                ->groupBy('schedule.UUID')
                ->orderBy('schedule.created_at', 'DESC')
                ->skip(0)->take($limit)
                ->get();
    }
    
    
    public function getPlayerRatinsForEachScheuleRaw($playerID)
    {
        return $this->select('schedule.UUID','schedule.name','schedule.date_date', 'player_ratings.rating')
                ->join('schedule_players', 'schedule_players.UUID', '=','player_ratings.scheduled_players_id')
                ->join('schedule', 'schedule.UUID', '=', 'schedule_players.schedule_id')
                ->where('schedule_players.player_id', $playerID)
                ->orderBy('schedule.created_at', 'DESC')
                ->get();
    }
    
    public function getPlayerRatinsForCurrentScheuleRaw($scheduleID, $playerID)
    {
        return $this->select('schedule.UUID','schedule.name','schedule.date_date', 'player_ratings.rating')
                ->join('schedule_players', 'schedule_players.UUID', '=','player_ratings.scheduled_players_id')
                ->join('schedule', 'schedule.UUID', '=', 'schedule_players.schedule_id')
                ->where('schedule_players.player_id', $playerID)
                ->where('schedule.UUID', $scheduleID)
                ->orderBy('schedule.created_at', 'DESC')
                ->get();
    }
    
    
}
