<?php

/*
*
* INFOATCLUSTER TECHNOLABS LLP ("COMPANY") CONFIDENTIAL
* Copyright (c) 2016-2017 INFOATCLUSTER TECHNOLABS LLP, All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains the property of INFOATCLUSTER TECHNOLABS LLP. The intellectual and technical concepts contained
* herein are proprietary to INFOATCLUSTER TECHNOLABS LLP and may be covered by Indian and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
* Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained
* from COMPANY.  Access to the source code contained herein is hereby forbidden to anyone except current COMPANY employees, managers or contractors who have executed 
* Confidentiality and Non-disclosure agreements explicitly covering such access.
*
* The copyright notice above does not evidence any actual or intended publication or disclosure  of  this source code, which includes  
* information that is confidential and/or proprietary, and is a trade secret, of  COMPANY.   ANY REPRODUCTION, MODIFICATION, DISTRIBUTION, PUBLIC  PERFORMANCE, 
* OR PUBLIC DISPLAY OF OR THROUGH USE  OF THIS  SOURCE CODE  WITHOUT  THE EXPRESS WRITTEN CONSENT OF COMPANY IS STRICTLY PROHIBITED, AND IN VIOLATION OF APPLICABLE 
* LAWS AND INTERNATIONAL TREATIES.  THE RECEIPT OR POSSESSION OF  THIS SOURCE CODE AND/OR RELATED INFORMATION DOES NOT CONVEY OR IMPLY ANY RIGHTS  
* TO REPRODUCE, DISCLOSE OR DISTRIBUTE ITS CONTENTS, OR TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT  MAY DESCRIBE, IN WHOLE OR IN PART.                
*
*
* @author Mohammed Shayas M K
* 
*/

namespace App\Managers\Tactics;
use App\Managers\Tactics\TacticsModel;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Session;
use App\Http\Helper\Helper;
use Illuminate\Support\Facades\DB;
use App\Managers\TacticContainer\TacticContainerManager;
use App\Managers\Paypal\PaypalManager;

class TacticsManager extends TacticsModel
{
    public function __construct()
    {
        
        $this->helper = new Helper();
        $this->paypal = new PaypalManager();
    }

    public function add($columns, $data, $votes)
    {
        DB::beginTransaction();
        try 
        {
            $this->tacticContainerManager = new TacticContainerManager();
            $userBalanceVote = $data['votes'];
            $data1 = $data;
            $data1['UUID'] = $this->helper->addUUID();;
            
            $data1['user_id'] = Session::get('general');
            $data1['created_at'] = $data['updated_at'] = date("Y-m-d H:i:s");
            
            $tacticContainerID = $this->tacticContainerManager->insertGetId($data1);
            
            if(!$tacticContainerID)
            {
                return 0;
            }
            $tacticContainer = $this->tacticContainerManager->where('id', $tacticContainerID)->first();
            foreach($columns AS $key => $column)
            {
                if($key == 'undefined')
                {
                    return 0;
                }
                $data = array();
                $data['position_columns_id'] = $key;
                $data['player_id'] = $column;
                $data['user_id'] = Session::get('general');
                $data['tactic_container_id'] = $tacticContainer->UUID;
                $data['votes'] = $votes;
                $data['UUID'] = $this->helper->addUUID();
                $data['created_at'] = $data['updated_at'] = date("Y-m-d H:i:s");
                $insert = $this->insert($data);
                if(!$insert)
                {
                    return 0;
                }
            }
            
            $votes = $this->paypal->getAllCreditsOfUser(Session::get('general'));
            $end = 0;
//            foreach($votes AS $vote)
//            {
//                if($end == 0 && $vote['no_of_votes'] > $vote['used_votes'])
//                {
//                    $balanceVoteForTransaction = $vote['no_of_votes'] - $vote['used_votes'];
//                    $availableVote = $vote['no_of_votes'];
//                    if($balanceVoteForTransaction == $userBalanceVote || $balanceVoteForTransaction > $userBalanceVote)
//                    {
//                        $availableVote = ($userBalanceVote + $vote['used_votes']);
//                        $end = 1;
//                    }
//                    
//                    $data2['used_votes'] = $availableVote;
//                    $update = $this->paypal->where('id', $vote['id'])->update($data2);
//                    if(!$update)
//                    {
//                        return 0;
//                        exit;
//                    }
//
//                    $userBalanceVote = $userBalanceVote - $balanceVoteForTransaction;
//                }
//            }
            
            DB::commit();
            return 1;
        }
        catch(ValidationException $e)
        {
            DB::rollback();
            return 0;
        }
    }
    
    public function getHighesValuePlayer($positionID, $count, $scheduleID)
    {
        return $this->select(DB::raw("SUM(tactics.votes) as count"),'player.*', 'position.short_form', 'position.UUID AS position_id', 'position_columns.UUID AS position_columns_id')
                ->join('tactic_container', 'tactic_container.UUID', '=', 'tactics.tactic_container_id')
                ->join('position_columns', 'position_columns.UUID', '=', 'tactics.position_columns_id')
                ->join('player','player.UUID', '=', 'tactics.player_id')
                ->join('position', 'position.UUID', '=', 'position_columns.position_id')
                ->where('tactic_container.schedule_id', "$scheduleID")
                ->where('position_columns.position_id', "$positionID")
                ->groupBy('player.UUID')
                //->orderByRaw(\DB::raw("CAST(count AS unsigned) DESC"))
                ->orderBy('count', 'DESC')
                ->skip(0)->take($count)->get();
    }
    
    public function getCurrentTacticsPlayerVotes($playerID, $scheduleID, $positionID)
    {
        return $this->select(DB::raw("SUM(tactics.votes) as vote_count"))
                ->join('tactic_container', 'tactic_container.UUID', '=', 'tactics.tactic_container_id')
                ->join('position_columns', 'position_columns.UUID', '=', 'tactics.position_columns_id')
                ->where('tactic_container.schedule_id', "$scheduleID")
                ->where('tactics.player_id', "$playerID")
                ->where('position_columns.position_id', "$positionID")
             //   ->where('tactics.position_columns_id', "$positionColumnsID")
                ->where('tactic_container.deleted_at', NULL)
                
                ->groupBy('tactics.player_id')
                ->orderBy('vote_count')
                ->first();
    }
    
    public function getTacticsPlayersTotalVotes($scheduleID)
    {
        return $this->select(DB::raw("SUM(tactics.votes) as vote_count"), 'position.name AS position', 'position.UUID AS position_uuid', 'player.name AS player_name')
                ->join('tactic_container', 'tactic_container.UUID', '=', 'tactics.tactic_container_id')
                ->join('position_columns', 'position_columns.UUID', '=', 'tactics.position_columns_id')
                ->join('position', 'position.UUID', '=', 'position_columns.position_id')
                ->join('player', 'player.UUID', '=', 'tactics.player_id')
                ->where('tactic_container.schedule_id', $scheduleID)
            //    ->where('tactics.player_id', "$playerID")
            //    ->where('position_columns.position_id', "$positionID")
             //   ->where('tactics.position_columns_id', "$positionColumnsID")
                ->where('tactic_container.deleted_at', NULL)
                ->groupBy('position.UUID')
                ->groupBy('player.UUID')
                ->orderBy('position.name')
                ->orderBy('vote_count', 'DESC')
                ->get();
    }
    
    public function getTotalLikesByUser($tacticContainerID, $userID)
    {
        return $this->select(DB::raw('SUM(votes) AS total_likes'))->where('user_id', $userID)->where('tactic_container_id', $tacticContainerID)->first();
    }
}