<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class CreateUsersTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('users', function (Blueprint $table) {
            $table->bigIncrements('id')->unsigned();
            $table->uuid('UUID')->unique();
            $table->string('name');
            $table->string('email',191)->unique();
            $table->text('address')->nullable();
            $table->string('phone')->nullable();
            $table->string('password', 500);
            $table->string('type', 100)->default('general');
            $table->string('confirmation_code', 500)->nullable();
            $table->string('password_reset_code', 500)->nullable();
            $table->string('ip', 255)->nullable();
            $table->boolean('active')->default(0);
            $table->rememberToken();
            $table->timestamps();
            
            $table->softDeletes();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('users');
    }
}
