<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class CreateLiveProposalLikeCountTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('live_proposal_like_count', function (Blueprint $table) {
            $table->bigIncrements('id');
            $table->uuid('UUID')->unique();
            $table->uuid('live_proposal_id');
            $table->integer('no_of_likes');
            $table->uuid('user_id');
            $table->timestamps();
            
            $table->softDeletes();
            
            $table->foreign('live_proposal_id')->references('UUID')->on('live_proposal');
            $table->foreign('user_id')->references('UUID')->on('users');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('live_proposal_like_count');
    }
}
