<?php namespace GoogleMaps\ServiceProvider;

use Illuminate\Support\ServiceProvider;



class GoogleMapsServiceProvider extends ServiceProvider {
    
	/**
	 * Indicates if loading of the provider is deferred.
	 *
	 * @var bool
	 */
	protected $defer = true;
        

	/**
	 * Bootstrap the application services.
	 *
	 * @return void
	 */
	public function boot()
	{
            $this->publishes([
                    __DIR__.'/../config/googlemaps.php' => config_path('googlemaps.php'),
                ], 'googlemaps');             
       
	}

	/**
	 * Register the application services.
	 *
	 * @return void
	 */
	public function register()
	{

            $this->app->bind('GoogleMaps', function($app)
		{
			return new \GoogleMaps\GoogleMaps();
		});

            
            
	}
        /***/
        
	/**
	 * Get the services provided by the provider.
	 *
	 * @return array
	 */
	public function provides()
	{
            return array('GoogleMaps');
	}        
        
        

        
        

}
